#include <LCD5110_Graph.h>
#include<Wire.h>

//      SCK  - Pin 12
//      MOSI - Pin 11
//      DC   - Pin 10
//      RST  - Pin 8
//      CS   - Pin 9
//
LCD5110 myGLCD(12, 11, 10, 8, 9);

const int MPU_addr = 0x68; // I2C address of the MPU-6050
int16_t AcX, AcY, AcZ, Tmp, GyX, GyY, GyZ;

#define shoottime 5000

unsigned long MillisEnemy;
unsigned long lastMillis1;
unsigned long MillisFire;
unsigned long MillisFireMovement;
unsigned long score;
unsigned long backgroundmovement;

boolean schuss1 = false;
boolean schuss2 = false;
boolean schuss3 = false;
boolean schuss4 = false;
boolean schuss5 = false;

boolean coinplaced = false;
boolean coinbool = false;
int coinxpos = 120;
int coinypos;
int coincounter = 0;

int stonelive = 2;
int stone1xpos = 104;
int stone1ypos = 30;
boolean stone1 = false;
boolean stone1placed = false;

int stonelive2 = 2;
int stone2xpos = 100;
int stone2ypos = 30;
boolean stone2 = false;
boolean stone2placed = false;

int bg1pos = 0;
int bg2pos = 17;
int bg3pos = 34;
int bg4pos = 51;
int bg5pos = 68;

boolean comet1placed = false;
int comet1xPos = 84;
int comet1yPos = 0;
boolean comet1 = false;

boolean alive = true;

boolean schussgegner1 = false;
int shootenemy1xpos = 90;
int shootenemy1ypos = 90;

boolean schussgegner2 = false;
int shootenemy2xpos = 90;
int shootenemy2ypos = 4;

boolean enemy1placed = false;
boolean enemy1 = false;
int enemy1xPos = 93;
int enemy1yPos = 20;


boolean enemy2placed = false;
boolean enemy2 = false;
int enemy2xPos = 84;
int enemy2yPos = 20;


int shoot1ypos;
int shoot1xpos;
int shootblocker1;

int shoot2ypos;
int shoot2xpos;
int shootblocker2;

int shoot3ypos;
int shoot3xpos;
int shootblocker3;

int shoot4ypos;
int shoot4xpos;
int shootblocker4;

int shoot5ypos;
int shoot5xpos;

int firecounter = 0;
int xPos = 20;
int yPos = 20;
int facing = 0;
int titlescreen = 0;
int button = 2;
int scoreanzeige = 0;

extern uint8_t spacelinks[];
extern uint8_t spacerechts[];
extern uint8_t spaceoben[];
extern uint8_t spaceunten[];
extern uint8_t gyrohero[];
extern uint8_t fire1[];
extern uint8_t fire2[];
extern uint8_t fire3[];
extern uint8_t comet[];
extern uint8_t destruction[];
extern uint8_t enemy[];
extern uint8_t stone[];
extern uint8_t destruction1[];
extern uint8_t bg1[];
extern uint8_t bg2[];
extern uint8_t bg3[];
extern uint8_t bg4[];
extern uint8_t bg5[];
extern uint8_t coin[];
extern uint8_t stonebroken[];
extern uint8_t SmallFont[];
void setup() {
  randomSeed(analogRead(0));
  lastMillis1 = millis();
  MillisFire = millis();
  MillisEnemy = millis();
  MillisFireMovement = millis();
  score = millis();
  backgroundmovement = millis();
  pinMode(button, INPUT);
  Wire.begin();
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x6B);  // PWR_MGMT_1 register
  Wire.write(0);     // set to zero (wakes up the MPU-6050)
  Wire.endTransmission(true);
  Serial.begin(9600);

  myGLCD.InitLCD();
  myGLCD.setFont(SmallFont);
}

void loop() {


  if ((millis() - MillisEnemy) >= 50)
  {
    if (schussgegner2 == true)
    {
      shootenemy2xpos--;
      shootenemy2xpos--;
    }
    if (schussgegner1 == true)
    {
      shootenemy1xpos--;
      shootenemy1xpos--;
    }
    enemy1xPos--;
    enemy2xPos--;
    comet1xPos--;
    coinxpos--;
    stone1xpos--;
    stone2xpos--;
    Serial.println("Läuft");
    MillisEnemy = millis();
  }
  Serial.println(shootenemy2xpos);
  if ((millis() - score) >= 1000)
  {
    scoreanzeige++;
    score = millis();
  }

  if (titlescreen == 0)
  {
    myGLCD.setContrast(50);
    myGLCD.drawBitmap(0, 0, gyrohero, 84, 48);
    myGLCD.update();
    delay(3000);
    titlescreen++;
  }
   Serial.println(enemy2yPos);
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x3B);  // starting with register 0x3B (ACCEL_XOUT_H)
  Wire.endTransmission(false);
  Wire.requestFrom(MPU_addr, 14, true); // request a total of 14 registers
  AcY = Wire.read() << 8 | Wire.read(); // 0x3B (ACCEL_XOUT_H) & 0x3C (ACCEL_XOUT_L)
  AcX = Wire.read() << 8 | Wire.read(); // 0x3D (ACCEL_YOUT_H) & 0x3E (ACCEL_YOUT_L)
  //Serial.print("AcY = "); Serial.print(AcX);
  //Serial.print(" | AcX = "); Serial.println(AcY);

  myGLCD.setContrast(60);

  background();
  steuern();
  ausrichten();
  schuss();
  fire();
   shoot1en();
  enemygame();

  cometx();
  coins();
  stonex();
  stonex2();
  shoot2en();
  enemy2game();



  while (alive == false)
  {
    myGLCD.clrScr();
    tone(3, 1);
    myGLCD.drawBitmap(xPos, yPos, destruction1, 9, 9);
    myGLCD.update();
    delay(200);
    myGLCD.drawBitmap(xPos, yPos, destruction, 9, 9);
    myGLCD.update();
    delay(400);
    noTone(3);
    myGLCD.clrScr();
    myGLCD.drawRect(0, 0, 83, 47);
    myGLCD.drawRect(15, 0, 68, 47);
    myGLCD.print("Time :", CENTER, 6);
    myGLCD.printNumI(scoreanzeige, CENTER, 16);
    myGLCD.print("s", 54, 16);
    myGLCD.print("Score :", CENTER, 26);
    myGLCD.printNumI(coincounter, CENTER, 36);
    myGLCD.update();
    delay(2000);
    xPos = 20;
    yPos = 20;
    stone1xpos = 84;
    stone2xpos = 90;
    stone1 = false;
    stone2 = false;
    enemy1xPos = 100;
    enemy2xPos = 90;
    scoreanzeige = 0;
    comet1xPos = 84;
    comet1 = false;
    enemy1 = false;
    enemy2 = false;
    alive = true;
    schuss1 = false;
    schuss2 = false;
    schuss3 = false;
    schuss4 = false;
    schuss5 = false;
    schussgegner1 = false;
    schussgegner2 = false;
    coincounter = 0;

  }

  myGLCD.update();
  delay(10);
  myGLCD.clrScr();
}

void ausrichten()
{
  if (facing == 0 && alive == true)
  {
    myGLCD.drawBitmap(xPos, yPos, spacerechts, 9, 9);
  }
}
void steuern()
{
  if ( AcY > 3000)
  {
    if (yPos < 39)
    {
      yPos++;
      if ( AcY > 8000)
      {
        yPos++;
      }
      delay(10);
    }
  }
  //////////////
  if ( AcY < -3000)
  {

    if (yPos > 0)
    {
      yPos--;
      if ( AcY < -8000)
      {
        yPos--;
      }
      delay(10);
    }
  }
  ///////////////
  if ( AcX > 3000)
  {
    if (facing != 0)
    {
      facing = 0;
    }

    if (xPos < 75)
    {
      if ( AcX > 8000)
      {
        xPos++;
      }
      xPos++;
    }
  }
  ////////////////////
  if ( AcX < -3000)
  {
    if (xPos > 0)
    {
      if ( AcX < -8000)
      {
        xPos--;
      }
      xPos--;
    }
  }
}
void schuss ()
{
  if (schuss1 == false)
  {
    shoot1ypos = yPos + 4;
    shoot1xpos = xPos + 10;
    shootblocker1 = xPos + 10;
  }

  if (schuss2 == false)
  {
    shoot2ypos = yPos + 4;
    shoot2xpos = xPos + 10;
    shootblocker2 = xPos + 10;
  }

  if (schuss3 == false)
  {
    shoot3ypos = yPos + 4;
    shoot3xpos = xPos + 10;
    shootblocker3 = xPos + 10;
  }

  if (schuss4 == false)
  {
    shoot4ypos = yPos + 4;
    shoot4xpos = xPos + 10;
    shootblocker4 = xPos + 10;
  }

  if (schuss5 == false)
  {
    shoot5ypos = yPos + 4;
    shoot5xpos = xPos + 10;
  }

  if (digitalRead(button) == HIGH && schuss1 == false)
  {
    tone(3, 10);
    delay(10);
    schuss1 = true;

  }
  if (digitalRead(button) == HIGH && schuss1 == true && (shoot1xpos > shootblocker1 + 5))
  {
    schuss2 = true;
    tone(3, 10);
    delay(10);
  }
  if (digitalRead(button) == HIGH && schuss2 == true && (shoot2xpos > shootblocker2 + 5))
  {
    schuss3 = true;
    tone(3, 10);
    delay(10);
  }
  if (digitalRead(button) == HIGH && schuss3 == true && (shoot3xpos > shootblocker3 + 5))
  {
    schuss4 = true;
  }
  if (digitalRead(button) == HIGH && schuss4 == true && (shoot4xpos > shootblocker4 + 5))
  {
    schuss5 = true;
    tone(3, 10);
    delay(10);
  }
  if (digitalRead(button) == HIGH && schuss5 == true)
  {
    noTone(3);
  }
  if (schuss1 == true)
  {
    myGLCD.drawLine(shoot1xpos , shoot1ypos , shoot1xpos + 3 , shoot1ypos);
    if (shoot1xpos > 80)
    {
      schuss1 = false;
    }
  }
  if (schuss2 == true)
  {
    myGLCD.drawLine(shoot2xpos , shoot2ypos , shoot2xpos + 3 , shoot2ypos);
    if (shoot2xpos > 80)
    {
      schuss2 = false;
    }
  }
  if (schuss3 == true)
  {
    myGLCD.drawLine(shoot3xpos , shoot3ypos , shoot3xpos + 3 , shoot3ypos);
    if (shoot3xpos > 80)
    {
      schuss3 = false;
    }
  }
  if (schuss4 == true)
  {
    myGLCD.drawLine(shoot4xpos , shoot4ypos , shoot4xpos + 3 , shoot4ypos);
    if (shoot4xpos > 80)
    {
      schuss4 = false;
    }
  }
  if (schuss5 == true)
  {
    myGLCD.drawLine(shoot5xpos , shoot5ypos , shoot5xpos + 3 , shoot5ypos);
    if (shoot5xpos > 80)
    {
      schuss5 = false;
    }
  }
  if ((millis() - MillisFireMovement) >= 50)
  {
    shoot1xpos++;
    shoot2xpos++;
    shoot3xpos++;
    shoot4xpos++;
    shoot5xpos++;
    MillisFireMovement = millis();
  }
  noTone(3);
}
void fire()
{
  if ( alive == true)
  {
    if ((millis() - MillisFire) >= 400)
    {
      firecounter++;
    }
    if (firecounter == 0)
    {
      myGLCD.drawBitmap(xPos - 3, yPos + 3, fire3, 3, 3);
    }
    if (firecounter == 1)
    {
      myGLCD.drawBitmap(xPos - 3, yPos + 3, fire2, 3, 3);
    }
    if (firecounter == 2)
    {
      myGLCD.drawBitmap(xPos - 3, yPos + 3, fire1, 3, 3);
    }
    if (firecounter == 3)
    {
      firecounter = 0;
    }
  }
}
void enemygame()
{
  if (enemy1 == false)
  {
    int enemytest = random(0, 4);


    if (enemytest == 0 && (comet1yPos != 0 || comet1xPos < 70 ) && (coinypos != 0 || coinxpos < 70 ) && (stone1ypos != 0 || stone1xpos < 70 ) && (enemy2yPos != 0 || enemy2xPos < 70 ) && (stone2ypos != 0 || stone2xpos < 70 ))
    {
      enemy1xPos = 90;
      enemy1yPos = 0;
      enemy1placed = true;
    }

    if (enemytest == 1 && (comet1yPos != 10 || comet1xPos < 70 ) && (coinypos != 10 || coinxpos < 70 ) && (stone1ypos != 10 || stone1xpos < 70 ) && (enemy2yPos != 10 || enemy2xPos < 70 ) && (stone2ypos != 10 || stone2xpos < 70 ))
    {
      enemy1xPos = 90;
      enemy1yPos = 10;
      enemy1placed = true;
    }

    if (enemytest == 2 && (comet1yPos != 20 || comet1xPos < 70 ) && (coinypos != 20 || coinxpos < 70 ) && (stone1ypos != 20 || stone1xpos < 70 ) && (enemy2yPos != 20 || enemy2xPos < 70 ) && (stone2ypos != 20 || stone2xpos < 70 ))
    {
      enemy1xPos = 90;
      enemy1yPos = 20;
      enemy1placed = true;
    }

    if (enemytest == 3 && (comet1yPos != 30 || comet1xPos < 70 ) && (coinypos != 30 || coinxpos < 70 ) && (stone1ypos != 30 || stone1xpos < 70 ) && (enemy2yPos != 30 || enemy2xPos < 70 ) && (stone2ypos != 30 || stone2xpos < 70 ))
    {
      enemy1xPos = 90;
      enemy1yPos = 30;
      enemy1placed = true;
    }

    if (enemytest == 4 && (comet1yPos != 39 || comet1xPos < 70 ) && (coinypos != 39 || coinxpos < 70 ) && (stone1ypos != 39 || stone1xpos < 70 ) && (enemy2yPos != 39 || enemy2xPos < 70 ) && (stone2ypos != 39 || stone2xpos < 70 ))
    {
      enemy1xPos = 90;
      enemy1yPos = 39;
      enemy1placed = true;
    }

    enemy1 = true;

    if (enemy1placed == false)
    {
      //Serial.println("Gegener 1 Reset");
      enemy1 = false;
      enemy1placed = false;
    }
  }

  myGLCD.drawBitmap(enemy1xPos, enemy1yPos, enemy, 9, 9);


  if (enemy1xPos < -9)
  {
    enemy1 = false;
    enemy1placed = false;
  }


  if ((shoot1xpos == enemy1xPos) || ( shoot1xpos + 1 == enemy1xPos) )
  {
    if (shoot1ypos >= enemy1yPos && shoot1ypos <= (enemy1yPos + 9) && schuss1 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      // Serial.println("Schuss1 getroffen");
      schuss1 = false;
      enemy1placed = false;
      enemy1 = false;
      enemy1xPos = 84;
      delay(10);
    }
  }
  if ((shoot2xpos == enemy1xPos) || ( shoot2xpos + 1 == enemy1xPos) )
  {
    if (shoot2ypos >= enemy1yPos && shoot2ypos <= (enemy1yPos + 9) && schuss2 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss2 = false;
      enemy1placed = false;
      enemy1 = false;
      enemy1xPos = 84;
      delay(10);
    }
  }
  if ((shoot3xpos == enemy1xPos) || ( shoot3xpos + 1 == enemy1xPos))
  {
    if (shoot3ypos >= enemy1yPos && shoot3ypos <= (enemy1yPos + 9) && schuss3 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss3 = false;
      enemy1placed = false;
      enemy1 = false;
      enemy1xPos = 84;
      delay(10);
    }
  }
  if ((shoot4xpos == enemy1xPos) || ( shoot4xpos + 1 == enemy1xPos) )
  {
    if (shoot4ypos >= enemy1yPos && shoot4ypos <= (enemy1yPos + 9) && schuss4 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss4 = false;
      enemy1placed = false;
      enemy1 = false;
      enemy1xPos = 84;
      delay(10);
    }
  }
  if ((shoot5xpos == enemy1xPos) || ( shoot5xpos + 1 == enemy1xPos) )
  {
    if (shoot5ypos >= enemy1yPos && shoot5ypos <= (enemy1yPos + 9) && schuss5 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss5 = false;
      enemy1placed = false;
      enemy1 = false;
      enemy1xPos = 84;
      delay(10);
    }
  }
  if ((enemy1xPos >= xPos + 6) && (enemy1xPos <= xPos + 9))
  {
    if ((enemy1yPos <= yPos + 6) && (enemy1yPos >= yPos - 6))
    {
      alive = false;
    }
  }

  if ((enemy1xPos <= xPos + 2) && (enemy1xPos >= xPos - 9))
  {
    if ((enemy1yPos <= yPos + 8) && (enemy1yPos >= yPos - 8))
    {
      alive = false;
    }
  }
}

void shoot1en()
{
  myGLCD.drawLine(shootenemy1xpos , shootenemy1ypos , shootenemy1xpos + 3 , shootenemy1ypos);

  if (schussgegner1 == false)
  {
    shootenemy1ypos = enemy1yPos + 4;
    shootenemy1xpos = enemy1xPos ;
  }

  if (enemy1xPos <= 84 && enemy1xPos >= 10 )
  {
    schussgegner1 = true;
  }
  else
  {
    schussgegner1 = false;
  }

  if ((shootenemy1xpos >= xPos) && (shootenemy1xpos <= xPos + 8))
  {
    if ((shootenemy1ypos >= yPos) && (shootenemy1ypos <= yPos + 8))
    {
      alive = false;
    }
  }
}

void cometx()
{
  myGLCD.drawBitmap(comet1xPos, comet1yPos, comet, 9, 9);
  if (comet1xPos < -9)
  {
    comet1placed = false;
    comet1 = false;
    comet1xPos = 84;
  }
  if (comet1 == false)
  {
    int comet1test = random(0, 5);

    if (comet1test == 0 && (enemy1yPos != 0 || enemy1xPos < 70 ) && (coinypos != 0 || coinxpos < 70 ) && (stone1ypos != 0 || stone1xpos < 70 ) && (stone2ypos != 0 || stone2xpos < 70 ) && (enemy2yPos != 0 || enemy2xPos < 70 ))
    {
      comet1yPos = 0;
      comet1placed = true;
    }

    if (comet1test == 1 && (enemy1yPos != 10 || enemy1xPos < 70 ) && (coinypos != 10 || coinxpos < 70 ) && (stone1ypos != 10 || stone1xpos < 70 ) && (stone2ypos != 10 || stone2xpos < 70 ) && (enemy2yPos != 10 || enemy2xPos < 70 ))
    {
      comet1yPos = 10;
      comet1placed = true;
    }

    if (comet1test == 2 && (enemy1yPos != 20 || enemy1xPos < 70 ) && (coinypos != 20 || coinxpos < 70 ) && (stone1ypos != 20 || stone1xpos < 70 ) && (stone2ypos != 20 || stone2xpos < 70 ) && (enemy2yPos != 20 || enemy2xPos < 70 ))
    {
      comet1yPos = 20;
      comet1placed = true;
    }

    if (comet1test == 3 && (enemy1yPos != 30 || enemy1xPos < 70 ) && (coinypos != 30 || coinxpos < 70 ) && (stone1ypos != 30 || stone1xpos < 70 ) && (stone2ypos != 30 || stone2xpos < 70 ) && (enemy2yPos != 30 || enemy2xPos < 70 ))
    {
      comet1yPos = 30;
      comet1placed = true;
    }

    if (comet1test == 4 && (enemy1yPos != 39 || enemy1xPos < 70 ) && (coinypos != 39 || coinxpos < 70 ) && (stone1ypos != 39 || stone1xpos < 70 ) && (stone2ypos != 39 || stone2xpos < 70 ) && (enemy2yPos != 39 || enemy2xPos < 70 ))
    {
      comet1yPos = 39;
      comet1placed = true;
    }
    comet1 = true;

    if ( comet1placed == false)
    {
      comet1 = false;
    }
  }
  if ((comet1xPos <= xPos + 8) && (comet1xPos >= xPos - 8))
  {
    if ((comet1yPos <= yPos + 4) && (comet1yPos >= yPos - 4))
    {
      alive = false;
    }
  }

  if ((comet1xPos <= xPos + 4) && (comet1xPos >= xPos - 4))
  {
    if ((comet1yPos <= yPos + 8) && (comet1yPos >= yPos - 8))
    {
      alive = false;
    }
  }

  if (((shoot1xpos == comet1xPos) || ( shoot1xpos + 1 == comet1xPos)) )
  {
    if (shoot1ypos >= comet1yPos && shoot1ypos <= (comet1yPos + 9) && schuss1 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss1 = false;
      comet1placed = false;
      comet1 = false;
      comet1xPos = 84;
      delay(10);
    }
  }

  if ((shoot2xpos == comet1xPos) || ( shoot2xpos + 1 == comet1xPos) )
  {
    if (shoot2ypos >= comet1yPos && shoot2ypos <= (comet1yPos + 9) && schuss2 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss2 = false;
      comet1placed = false;
      comet1 = false;
      comet1xPos = 84;
      delay(10);
    }
  }

  if (((shoot3xpos == comet1xPos) || ( shoot3xpos + 1 == comet1xPos)) )
  {
    if (shoot3ypos >= comet1yPos && shoot3ypos <= (comet1yPos + 9) && schuss3 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss3 = false;
      comet1placed = false;
      comet1 = false;
      comet1xPos = 84;
      delay(10);
    }
  }

  if (((shoot4xpos == comet1xPos) || ( shoot4xpos + 1 == comet1xPos)) )
  {
    if (shoot4ypos >= comet1yPos && shoot4ypos <= (comet1yPos + 9) && schuss4 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss4 = false;
      comet1placed = false;
      comet1 = false;
      comet1xPos = 84;
      delay(10);
    }
  }

  if (((shoot5xpos == comet1xPos) || ( shoot5xpos + 1 == comet1xPos)) )
  {
    if (shoot5ypos >= comet1yPos && shoot5ypos <= (comet1yPos + 9) && schuss5 == true)
    {
      myGLCD.drawBitmap(comet1xPos, comet1yPos, destruction, 9, 9);
      schuss5 = false;
      comet1placed = false;
      comet1 = false;
      comet1xPos = 84;
      delay(10);
    }
  }

}
void background()
{
  if ((millis() - backgroundmovement) >= 50)
  {
    bg1pos--;
    bg2pos--;
    bg3pos--;
    bg4pos--;
    bg5pos--;
    backgroundmovement = millis();
  }
  myGLCD.drawBitmap(bg1pos, 0, bg1, 1, 48);
  myGLCD.drawBitmap(bg2pos, 0, bg2, 1, 48);
  myGLCD.drawBitmap(bg3pos, 0, bg3, 1, 48);
  myGLCD.drawBitmap(bg4pos, 0, bg4, 1, 48);
  myGLCD.drawBitmap(bg5pos, 0, bg5, 1, 48);

  if (bg1pos < 0)
  {
    bg1pos = 84;
  }

  if (bg2pos < 0)
  {
    bg2pos = 84;
  }

  if (bg3pos < 0)
  {
    bg3pos = 84;
  }

  if (bg4pos < 0)
  {
    bg4pos = 84;
  }

  if (bg5pos < 0)
  {
    bg5pos = 84;
  }
}
void coins()
{
  if (coinxpos < -9)
  {
    coinxpos = 86;
    coinbool = false;
    coinplaced = false;
  }

  myGLCD.drawBitmap(coinxpos, coinypos, coin, 9, 9);

  if (coinbool == false)
  {
    int cointest = random(0, 5);

    if (cointest == 0 && (enemy1yPos != 0 || enemy1xPos < 70 ) && (comet1yPos != 0 || comet1xPos < 70 ) && (stone1ypos != 0 || stone1xpos < 70 ) && (stone2ypos != 0 || stone2xpos < 70 ) && (enemy2yPos != 0 || enemy2xPos < 70 ))
    {
      coinypos = 0;
      coinplaced = true;
    }

    if (cointest == 1 && (enemy1yPos != 10 || enemy1xPos < 70 ) && (comet1yPos != 10 || comet1xPos < 70 ) && (stone1ypos != 10 || stone1xpos < 70 ) && (stone2ypos != 10 || stone2xpos < 70 ) && (enemy2yPos != 10 || enemy2xPos < 70 ))
    {
      coinypos = 10;
      coinplaced = true;
    }

    if (cointest == 2 && (enemy1yPos != 20 || enemy1xPos < 70 ) && (comet1yPos != 20 || comet1xPos < 70 ) && (stone1ypos != 20 || stone1xpos < 70 ) && (stone2ypos != 20 || stone2xpos < 70 ) && (enemy2yPos != 20 || enemy2xPos < 70 ))
    {
      coinypos = 20;
      coinplaced = true;
    }

    if (cointest == 3 && (enemy1yPos != 30 || enemy1xPos < 70 ) && (comet1yPos != 30 || comet1xPos < 70 ) && (stone1ypos != 30 || stone1xpos < 70 ) && (stone2ypos != 30 || stone2xpos < 70 ) && (enemy2yPos != 30 || enemy2xPos < 70 ))
    {
      coinypos = 30;
      coinplaced = true;
    }

    if (cointest == 4 && (enemy1yPos != 39 || enemy1xPos < 70 ) && (comet1yPos != 39 || comet1xPos < 70 ) && (stone1ypos != 39 || stone1xpos < 70 ) && (stone2ypos != 39 || stone2xpos < 70 ) && (enemy2yPos != 39 || enemy2xPos < 70 ))
    {
      coinypos = 39;
      coinplaced = true;
    }

    coinbool = true;
    if (coinplaced == false)
    {
      coinbool = false;
    }
  }
  if ((coinxpos <= xPos + 9) && (coinxpos >= xPos - 9))
  {
    if ((coinypos <= yPos + 8) && (coinypos >= yPos - 8))
    {
      tone(3, 10);
      delay(10);
      coincounter++;
      coinxpos = 100;
      coinbool = false;
      noTone(3);
    }
  }
}

void stonex()
{
  if (stonelive == 2)
  {
    myGLCD.drawBitmap(stone1xpos, stone1ypos, stone, 9, 9);
  }

  if (stonelive == 1)
  {
    myGLCD.drawBitmap(stone1xpos, stone1ypos, stonebroken, 9, 9);
  }


  if ((stone1xpos <= xPos + 4) && (stone1xpos >= xPos - 4))
  {
    if ((stone1ypos <= yPos + 8) && (stone1ypos >= yPos - 8))
    {
      alive = false;
    }
  }
  if ((stone1xpos <= xPos + 8) && (stone1xpos >= xPos - 8))
  {
    if ((stone1ypos <= yPos + 4) && (stone1ypos >= yPos - 4))
    {
      alive = false;
    }
  }
  if (((shoot1xpos == stone1xpos) || ( shoot1xpos + 1 == stone1xpos)) )
  {
    if (shoot1ypos >= stone1ypos && shoot1ypos <= (stone1ypos + 9) && schuss1 == true)
    {
      schuss1 = false;
      stonelive--;
      delay(10);
    }
  }
  if (((shoot2xpos == stone1xpos) || ( shoot2xpos + 1 == stone1xpos)) )
  {
    if (shoot2ypos >= stone1ypos && shoot2ypos <= (stone1ypos + 9) && schuss2 == true)
    {
      schuss2 = false;
      stonelive--;
      delay(10);
    }
  }
  if (((shoot3xpos == stone1xpos) || ( shoot3xpos + 1 == stone1xpos)) )
  {
    if (shoot3ypos >= stone1ypos && shoot3ypos <= (stone1ypos + 9) && schuss3 == true)
    {
      schuss3 = false;
      stonelive--;
      delay(10);
    }
  }
  if (((shoot4xpos == stone1xpos) || ( shoot4xpos + 1 == stone1xpos)) )
  {
    if (shoot4ypos >= stone1ypos && shoot4ypos <= (stone1ypos + 9) && schuss4 == true)
    {
      schuss4 = false;
      stonelive--;
      delay(10);
    }
  }
  if (((shoot5xpos == stone1xpos) || ( shoot5xpos + 1 == stone1xpos)) )
  {
    if (shoot5ypos >= stone1ypos && shoot5ypos <= (stone1ypos + 9) && schuss5 == true)
    {

      schuss5 = false;
      stonelive--;
      delay(10);
    }
  }

  if (stonelive <= 0)
  {
    stone1xpos = 90;
    stone1 = false;
    stone1placed = false;
  }

  if (stone1xpos < -9)
  {
    stone1xpos = 90;
    stone1 = false;
    stonelive = 2;
    stone1placed = false;
  }
  if (stone1 == false)
  {
    int stone1test = random(0, 5);

    if (stone1test == 0 && (enemy1yPos != 0 || enemy1xPos < 70 ) && (coinypos != 0 || coinxpos < 70 ) && (comet1yPos != 0 || comet1xPos < 70 ) && (stone2ypos != 0 || stone2xpos < 70 ) && (enemy2yPos != 0 || enemy2xPos < 70 ))
    {
      stone1ypos = 0;
      stonelive = 2;
      stone1placed = true;
    }

    if (stone1test == 1 && (enemy1yPos != 10 || enemy1xPos < 70 ) && (coinypos != 10 || coinxpos < 70 ) && (comet1yPos != 10 || comet1xPos < 70 ) && (stone2ypos != 10 || stone2xpos < 70 ) && (enemy2yPos != 10 || enemy2xPos < 70 ))
    {
      stone1ypos = 10;
      stonelive = 2;
      stone1placed = true;
    }

    if (stone1test == 2 && (enemy1yPos != 20 || enemy1xPos < 70 ) && (coinypos != 20 || coinxpos < 70 ) && (comet1yPos != 20 || comet1xPos < 70 ) && (stone2ypos != 20 || stone2xpos < 70 ) && (enemy2yPos != 20 || enemy2xPos < 70 ))
    {
      stone1ypos = 20;
      stonelive = 2;
      stone1placed = true;
    }

    if (stone1test == 3 && (enemy1yPos != 30 || enemy1xPos < 70 ) && (coinypos != 30 || coinxpos < 70 ) && (comet1yPos != 30 || comet1xPos < 70 ) && (stone2ypos != 30 || stone2xpos < 70 ) && (enemy2yPos != 30 || enemy2xPos < 70 ))
    {
      stone1ypos = 30;
      stonelive = 2;
      stone1placed = true;
    }

    if (stone1test == 4 && (enemy1yPos != 39 || enemy1xPos < 70 ) && (coinypos != 39 || coinxpos < 70 ) && (comet1yPos != 39 || comet1xPos < 70 ) && (stone2ypos != 39 || stone2xpos < 70 ) && (enemy2yPos != 39 || enemy2xPos < 70 ))
    {
      stone1ypos = 39;
      stonelive = 2;
      stone1placed = true;
    }

    stone1 = true;

    if ( stone1placed == false)
    {
      stone1 = false;
    }
  }
}
void stonex2()
{
  if (stonelive2 == 2)

  {
    myGLCD.drawBitmap(stone2xpos, stone2ypos, stone, 9, 9);
  }

  if (stonelive2 == 1)
  {
    myGLCD.drawBitmap(stone2xpos, stone2ypos, stonebroken, 9, 9);
  }


  if ((stone2xpos <= xPos + 4) && (stone2xpos >= xPos - 4))
  {
    if ((stone2ypos <= yPos + 8) && (stone2ypos >= yPos - 8))
    {
      alive = false;
    }
  }
  if ((stone2xpos <= xPos + 8) && (stone2xpos >= xPos - 8))
  {
    if ((stone2ypos <= yPos + 4) && (stone2ypos >= yPos - 4))
    {
      alive = false;
    }
  }
  if (((shoot1xpos == stone2xpos) || ( shoot1xpos + 1 == stone2xpos)) )
  {
    if (shoot1ypos >= stone2ypos && shoot1ypos <= (stone2ypos + 9) && schuss1 == true)
    {
      schuss1 = false;
      stonelive2--;
      delay(10);
    }
  }
  if (((shoot2xpos == stone2xpos) || ( shoot2xpos + 1 == stone2xpos)) )
  {
    if (shoot2ypos >= stone2ypos && shoot2ypos <= (stone2ypos + 9) && schuss2 == true)
    {
      schuss2 = false;
      stonelive2--;
      delay(10);
    }
  }
  if (((shoot3xpos == stone2xpos) || ( shoot3xpos + 1 == stone2xpos)) )
  {
    if (shoot3ypos >= stone2ypos && shoot3ypos <= (stone2ypos + 9) && schuss3 == true)
    {
      schuss3 = false;
      stonelive2--;
      delay(10);
    }
  }
  if (((shoot4xpos == stone2xpos) || ( shoot4xpos + 1 == stone2xpos)) )
  {
    if (shoot4ypos >= stone2ypos && shoot4ypos <= (stone2ypos + 9) && schuss4 == true)
    {
      schuss4 = false;
      stonelive2--;
      delay(10);
    }
  }
  if (((shoot5xpos == stone2xpos) || ( shoot5xpos + 1 == stone2xpos)) )
  {
    if (shoot5ypos >= stone2ypos && shoot5ypos <= (stone2ypos + 9) && schuss5 == true)
    {

      schuss5 = false;
      stonelive2--;
      delay(10);
    }
  }

  if (stonelive2 <= 0)
  {
    stone2xpos = 90;
    stone2 = false;
    stone2placed = false;
  }

  if (stone2xpos < -9)
  {
    stone2xpos = 90;
    stone2 = false;
    stonelive2 = 2;
    stone2placed = false;
  }
  if (stone2 == false)
  {
    int stone2test = random(0, 5);

    if (stone2test == 0 && (enemy1yPos != 0 || enemy1xPos < 70 ) && (coinypos != 0 || coinxpos < 70 ) && (comet1yPos != 0 || comet1xPos < 70 ) && (stone1ypos != 0 || stone1xpos < 70 ) && (enemy2yPos != 0 || enemy2xPos < 70 ))
    {
      stone2ypos = 0;
      stonelive2 = 2;
      stone2placed = true;
    }

    if (stone2test == 1 && (enemy1yPos != 10 || enemy1xPos < 70 ) && (coinypos != 10 || coinxpos < 70 ) && (comet1yPos != 10 || comet1xPos < 70 ) && (stone1ypos != 10 || stone1xpos < 70 ) && (enemy2yPos != 10 || enemy2xPos < 70 ))
    {
      stone2ypos = 10;
      stonelive2 = 2;
      stone2placed = true;
    }

    if (stone2test == 2 && (enemy1yPos != 20 || enemy1xPos < 70 ) && (coinypos != 20 || coinxpos < 70 ) && (comet1yPos != 20 || comet1xPos < 70 ) && (stone1ypos != 20 || stone1xpos < 70 ) && (enemy2yPos != 20 || enemy2xPos < 70 ))
    {
      stone2ypos = 20;
      stonelive2 = 2;
      stone2placed = true;
    }

    if (stone2test == 3 && (enemy1yPos != 30 || enemy1xPos < 70 ) && (coinypos != 30 || coinxpos < 70 ) && (comet1yPos != 30 || comet1xPos < 70 ) && (stone1ypos != 30 || stone1xpos < 70 ) && (enemy2yPos != 30 || enemy2xPos < 70 ))
    {
      stone2ypos = 30;
      stonelive2 = 2;
      stone2placed = true;
    }

    if (stone2test == 4 && (enemy1yPos != 39 || enemy1xPos < 70 ) && (coinypos != 39 || coinxpos < 70 ) && (comet1yPos != 39 || comet1xPos < 70 ) && (stone1ypos != 39 || stone1xpos < 70 ) && (enemy2yPos != 39 || enemy2xPos < 70 ))
    {
      stone2ypos = 39;
      stonelive2 = 2;
      stone2placed = true;
    }

    stone2 = true;

    if ( stone2placed == false)
    {
      stone2 = false;
    }
  }
}
void enemy2game()
{
  if (enemy2 == false)
  {
    int enemytest2 = random(0, 4);

    if (enemytest2 == 0 && (comet1yPos != 0 || comet1xPos < 70 ) && (coinypos != 0 || coinxpos < 70 ) && (stone1ypos != 0 || stone1xpos < 70 ) && (stone2ypos != 0 || stone2xpos < 70 ) && (enemy1yPos != 0 || enemy1xPos < 70 ))
    {
      //shootenemy2ypos = 4;
      enemy2xPos = 90;
      enemy2yPos = 0;
      enemy2placed = true;
    }

    if (enemytest2 == 1 && (comet1yPos != 10 || comet1xPos < 70 ) && (coinypos != 10 || coinxpos < 70 ) && (stone1ypos != 10 || stone1xpos < 70 ) && (stone2ypos != 10 || stone2xpos < 70 ) && (enemy1yPos != 10 || enemy1xPos < 70 ))
    {
      //shootenemy2ypos = 14;
      enemy2xPos = 90;
      enemy2yPos = 10;
      enemy2placed = true;
    }

    if (enemytest2 == 2 && (comet1yPos != 20 || comet1xPos < 70 ) && (coinypos != 20 || coinxpos < 70 ) && (stone1ypos != 20 || stone1xpos < 70 ) && (stone2ypos != 20 || stone2xpos < 70 ) && (enemy1yPos != 20 || enemy1xPos < 70 ))
    {
      //shootenemy2ypos = 24;
      enemy2xPos = 90;
      enemy2yPos = 20;
      enemy2placed = true;
    }

    if (enemytest2 == 3 && (comet1yPos != 30 || comet1xPos < 70 ) && (coinypos != 30 || coinxpos < 70 ) && (stone1ypos != 30 || stone1xpos < 70 ) && (stone2ypos != 30 || stone2xpos < 70 ) && (enemy1yPos != 30 || enemy1xPos < 70 ))
    {
      //shootenemy2ypos = 34;
      enemy2xPos = 90;
      enemy2yPos = 30;
      enemy2placed = true;
    }

    if (enemytest2 == 4 && (comet1yPos != 39 || comet1xPos < 70 ) && (coinypos != 39 || coinxpos < 70 ) && (stone1ypos != 39 || stone1xpos < 70 ) && (stone2ypos != 39 || stone2xpos < 70 ) && (enemy1yPos != 39 || enemy1xPos < 70 ))
    {
      //shootenemy2ypos = 43;
      enemy2xPos = 90;
      enemy2yPos = 39;
      enemy2placed = true;
    }

    enemy2 = true;

    if (enemy2placed == false)
    {
      
      //Serial.println("Gegener 2 Reset");
      enemy2xPos = 90;
      enemy2 = false;
      enemy2placed = false;
    }

  }
  myGLCD.drawBitmap(enemy2xPos, enemy2yPos, enemy, 9, 9);

  if (enemy2xPos < -9)
  {
    enemy2 = false;
    enemy2placed = false;
  }


  if ((shoot1xpos == enemy2xPos) || ( shoot1xpos + 1 == enemy2xPos) )
  {
    if (shoot1ypos >= enemy2yPos && shoot1ypos <= (enemy2yPos + 9) && schuss1 == true)
    {
      schuss1 = false;
      enemy2placed = false;
      enemy2 = false;
      enemy2xPos = 84;
    }
  }
  if ((shoot2xpos == enemy2xPos) || ( shoot2xpos + 1 == enemy2xPos) )
  {
    if (shoot2ypos >= enemy2yPos && shoot2ypos <= (enemy2yPos + 9) && schuss2 == true)
    {
      schuss2 = false;
      enemy2placed = false;
      enemy2 = false;
      enemy2xPos = 84;
    }
  }
  if ((shoot3xpos == enemy2xPos) || ( shoot3xpos + 1 == enemy2xPos))
  {
    if (shoot3ypos >= enemy2yPos && shoot3ypos <= (enemy2yPos + 9) && schuss3 == true)
    {
      schuss3 = false;
      enemy2placed = false;
      enemy2 = false;
      enemy2xPos = 84;
    }
  }
  if ((shoot4xpos == enemy2xPos) || ( shoot4xpos + 1 == enemy2xPos) )
  {
    if (shoot4ypos >= enemy2yPos && shoot4ypos <= (enemy2yPos + 9) && schuss4 == true)
    {
      schuss4 = false;
      enemy2placed = false;
      enemy2 = false;
      enemy2xPos = 84;
    }
  }
  if ((shoot5xpos == enemy2xPos) || ( shoot5xpos + 1 == enemy2xPos) )
  {
    if (shoot5ypos >= enemy2yPos && shoot5ypos <= (enemy2yPos + 9) && schuss5 == true)
    {
      schuss5 = false;
      enemy2placed = false;
      enemy2 = false;
      enemy2xPos = 84;
    }
  }
  if ((enemy2xPos >= xPos + 6) && (enemy2xPos <= xPos + 9))
  {
    if ((enemy2yPos <= yPos + 6) && (enemy2yPos >= yPos - 6))
    {
      alive = false;
    }
  }

  if ((enemy2xPos <= xPos + 2) && (enemy2xPos >= xPos - 9))
  {
    if ((enemy2yPos <= yPos + 8) && (enemy2yPos >= yPos - 8))
    {
      alive = false;
    }
  }
  
  
  
 
}

void shoot2en()
{
  myGLCD.drawLine(shootenemy2xpos , shootenemy2ypos , shootenemy2xpos + 3 , shootenemy2ypos);

  if (schussgegner2 == false)
    {
    shootenemy2ypos = enemy2yPos + 4;
    shootenemy2xpos = enemy2xPos ;
    }
    if (enemy2xPos <= 84 && enemy2xPos >= 10)
    {
    schussgegner2 = true;
    }
    if(shootenemy2xpos < 0)
    {
    schussgegner2 = false;
    }
    if ((shootenemy2xpos >= xPos) && (shootenemy2xpos <= xPos + 8))
    {
    if ((shootenemy2ypos >= yPos) && (shootenemy2ypos <= yPos + 8))
    {
      alive = false;
    }
    }
  

}
